Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1902102 - Review Request: python-meautility - Package for multi-electrode array (MEA) handling and stimulation
Summary: Review Request: python-meautility - Package for multi-electrode array (MEA) h...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Andy Mender
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro, NeuroFedora 1902098
TreeView+ depends on / blocked
 
Reported: 2020-11-26 22:50 UTC by Ankur Sinha (FranciscoD)
Modified: 2020-12-09 01:22 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-12-09 01:16:30 UTC
Type: ---
Embargoed:
andymenderunix: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2020-11-26 22:50:19 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-meautility/python-meautility.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-meautility/python-meautility-1.4.8-1.fc33.src.rpm

Description: Python package for multi-electrode array (MEA) handling and stimulation.
Fedora Account System Username: ankursinha

Comment 1 Andy Mender 2020-11-27 12:05:14 UTC
Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=56322556

> URL:            https://github.com/alejoe91/%{pretty_name}/

Minor thing, but for the URL you can use %{pypi_name}. It will still reach it.

> %if %{with tests}
> BuildRequires:  %{py3_dist pytest}
> BuildRequires:  %{py3_dist numpy}
> BuildRequires:  %{py3_dist pyyaml}
> BuildRequires:  %{py3_dist matplotlib}
> %endif

Python dependencies should be declared using the format "python3dist(foo)".

> %package doc
> Summary:        %{summary}
> BuildRequires:  %{py3_dist ipython}
> BuildRequires:  %{py3_dist sphinx}
> BuildRequires:  %{py3_dist sphinx-rtd-theme}
> BuildRequires:  %{py3_dist numpy}

Not a hard requirement, but would it make sense to add a Requires on python3-%{pypi_name} to the -doc subpackage?

> # Comment out to remove /usr/bin/env shebangs
> # Can use something similar to correct/remove /usr/bin/python shebangs also
> # find . -type f -name "*.py" -exec sed -i '/^#![  ]*\/usr\/bin\/env.*$/ d' {} 2>/dev/null ';'

I guess this part should be re-enabled, right?

> PYTHONPATH=./ sphinx-build-%{python3_version} docs/source docs/build/
> rm -rf docs/build/{.doctrees,.buildinfo} -vf

From fedora-review:
> [!]: Avoid bundling fonts in non-fonts packages.
>      Note: Package contains font files

You might need to do some font unbundling if the Sphinx docs bundle font files.
Below SPEC file I'm currently updating does this very extensively:
https://src.fedoraproject.org/rpms/widelands/raw/master/f/widelands.spec

> %check
> %if %{with tests}
> pytest-%{python3_version}
> %endif

I would recommend using the %pytest macro instead.

Full review below:
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
     Note: Using prebuilt packages
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 58 files have unknown license. Detailed
     output of licensecheck in /data/rpmbuild/SPECS/python-
     meautility/python-meautility/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[!]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-meautility
     Review: not needed
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.


Rpmlint
-------
Checking: python3-meautility-1.4.8-1.fc34.noarch.rpm
          python-meautility-doc-1.4.8-1.fc34.noarch.rpm
          python-meautility-1.4.8-1.fc33.src.rpm
python-meautility-doc.noarch: W: description-shorter-than-summary
3 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
(none): E: no installed packages by name python-meautility-doc
(none): E: no installed packages by name python3-meautility
0 packages and 0 specfiles checked; 0 errors, 0 warnings.



Source checksums
----------------
https://github.com/alejoe91/MEAutility//archive/1.4.8/meautility-1.4.8.tar.gz :
  CHECKSUM(SHA256) this package     : 60b18bb05d1ca1f84401cb993ba68c5b1ab320c00609eaabd420dd8dd96c4c18
  CHECKSUM(SHA256) upstream package : 60b18bb05d1ca1f84401cb993ba68c5b1ab320c00609eaabd420dd8dd96c4c18


Requires
--------
python3-meautility (rpmlib, GLIBC filtered):
    python(abi)
    python3.9dist(matplotlib)
    python3.9dist(numpy)
    python3.9dist(pyyaml)

python-meautility-doc (rpmlib, GLIBC filtered):



Provides
--------
python3-meautility:
    python-meautility
    python3-meautility
    python3.9-meautility
    python3.9dist(meautility)
    python3dist(meautility)

python-meautility-doc:
    python-meautility-doc

Comment 2 Ankur Sinha (FranciscoD) 2020-11-27 15:48:52 UTC
Thanks very much for the review Andy,


(In reply to Andy Mender from comment #1)
> Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=56322556
> 
> > URL:            https://github.com/alejoe91/%{pretty_name}/
> 
> Minor thing, but for the URL you can use %{pypi_name}. It will still reach
> it.

Thanks, noted. I've just left it there to match the case used in the PyPi page.
> 
> > %if %{with tests}
> > BuildRequires:  %{py3_dist pytest}
> > BuildRequires:  %{py3_dist numpy}
> > BuildRequires:  %{py3_dist pyyaml}
> > BuildRequires:  %{py3_dist matplotlib}
> > %endif
> 
> Python dependencies should be declared using the format "python3dist(foo)".

The %{py3_dist ...} macro expands to the canonical form:
https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_requires_and_buildrequires_with_standardized_names

> 
> > %package doc
> > Summary:        %{summary}
> > BuildRequires:  %{py3_dist ipython}
> > BuildRequires:  %{py3_dist sphinx}
> > BuildRequires:  %{py3_dist sphinx-rtd-theme}
> > BuildRequires:  %{py3_dist numpy}
> 
> Not a hard requirement, but would it make sense to add a Requires on
> python3-%{pypi_name} to the -doc subpackage?

I've removed the docs sub-package entirely and referred to the online documentation. It's not worth the work to unbundle the fonts and then monitor changes in it for each update.

> 
> > # Comment out to remove /usr/bin/env shebangs
> > # Can use something similar to correct/remove /usr/bin/python shebangs also
> > # find . -type f -name "*.py" -exec sed -i '/^#![  ]*\/usr\/bin\/env.*$/ d' {} 2>/dev/null ';'
> 
> I guess this part should be re-enabled, right?

It wasn't needed in this package (rpmlint reports it), removed.


> > PYTHONPATH=./ sphinx-build-%{python3_version} docs/source docs/build/
> > rm -rf docs/build/{.doctrees,.buildinfo} -vf
> 
> From fedora-review:
> > [!]: Avoid bundling fonts in non-fonts packages.
> >      Note: Package contains font files
> 
> You might need to do some font unbundling if the Sphinx docs bundle font
> files.
> Below SPEC file I'm currently updating does this very extensively:
> https://src.fedoraproject.org/rpms/widelands/raw/master/f/widelands.spec

Removed docs and referred to the online documentation.
> 
> > %check
> > %if %{with tests}
> > pytest-%{python3_version}
> > %endif
> 
> I would recommend using the %pytest macro instead.
> 

Thanks updated.

Updated spec/srpm:
Spec URL: https://ankursinha.fedorapeople.org/python-meautility/python-meautility.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-meautility/python-meautility-1.4.8-1.fc33.src.rpm

* Fri Nov 27 2020 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 1.4.8-1
- Remove docs: bundle fonts
- Remove unneeded comments
- Use pytest macro

Comment 3 Andy Mender 2020-11-27 15:55:18 UTC
> The %{py3_dist ...} macro expands to the canonical form:
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_requires_and_buildrequires_with_standardized_names

You're completely right! I always missed it somehow...

> I've removed the docs sub-package entirely and referred to the online documentation. It's not worth the work to unbundle the fonts and then monitor changes in it for each update.

I agree. It's a lot of extra work.

> Updated spec/srpm:
> Spec URL: https://ankursinha.fedorapeople.org/python-meautility/python-meautility.spec
> SRPM URL: https://ankursinha.fedorapeople.org/python-meautility/python-meautility-1.4.8-1.fc33.src.rpm

> Name:           python-%{pypi_name}
> Version:        1.4.8
> Release:        1%{?dist}
> [...]
> %changelog
> * Fri Nov 27 2020 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 1.4.8-1
> - Remove docs: bundle fonts
> - Remove unneeded comments
> - Use pytest macro
> 
> * Thu Nov 26 2020 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 1.4.8-1
> - Initial build

Don't forget to bump the Release number in the changelog and the Release field :).

You can do it on package import. Approved!

Comment 4 Ankur Sinha (FranciscoD) 2020-11-27 16:06:19 UTC
Thanks very much. I'll go request the SCM now.

About the changelog: we can repeat change log entries with different dates until the E-V-R has been built:
https://docs.fedoraproject.org/en-US/packaging-guidelines/#_repeat_the_old_version_release_with_a_new_entry

I just tend to use this system so that when the package is built for the first time in the Fedora, it starts with 1 as release, as the first release for Fedora :)

Comment 5 Gwyn Ciesla 2020-11-30 14:32:41 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-meautility

Comment 6 Fedora Update System 2020-11-30 19:15:09 UTC
FEDORA-2020-0d25e90a78 has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2020-0d25e90a78

Comment 7 Fedora Update System 2020-12-01 02:00:26 UTC
FEDORA-2020-e2ea7fbce1 has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-e2ea7fbce1 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-e2ea7fbce1

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 8 Fedora Update System 2020-12-01 02:14:30 UTC
FEDORA-2020-0d25e90a78 has been pushed to the Fedora 33 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-0d25e90a78 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-0d25e90a78

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 9 Fedora Update System 2020-12-09 01:16:30 UTC
FEDORA-2020-0d25e90a78 has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 10 Fedora Update System 2020-12-09 01:22:55 UTC
FEDORA-2020-e2ea7fbce1 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.